diff -Naur --exclude=CVS --exclude=configs linux/hpc/balance.c linux-openmosix/hpc/balance.c
--- linux/hpc/balance.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/balance.c	2004-04-06 21:19:37.000000000 +0200
@@ -0,0 +1,1222 @@
+/* All changes since Feb 12, 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Amnon Shiloh, Amnon Barak, Moshe Bar
+ */
+
+
+#include <linux/module.h>
+#include <linux/sched.h>
+#include <linux/hpcctl.h>
+#include <net/sock.h>
+#include <hpc/defs.h>
+#include <hpc/routines.h>
+#include <hpc/protocol.h>
+#include <linux/hpc.h>
+#include <asm/uaccess.h>
+#include <asm/i387.h>
+#include <linux/smp_lock.h>
+#include <linux/swap.h>
+#include <linux/stddef.h>
+#include <hpc/comm.h>
+#include <hpc/debug.h>
+#include <hpc/hpcversion.h>
+#include <hpc/balance.h>
+#ifdef CONFIG_MOSIX_FS
+#include <linux/mfs.h>
+#endif /* CONFIG_MOSIX_FS */
+
+struct opcost remote_here_adjusted[MAX_MOSIX_TOPOLOGY];
+#ifndef CONFIG_MOSIX_TOPOLOGY
+struct opcost remote_here;
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+
+static int load_balancing_counter;
+static int memory_balancing_counter;
+
+
+void
+age_balancing(void)
+{
+	spin_lock_irq(&whereto_lock);
+	if(load_balancing_counter-- == 0 && chosen_for_balance)
+	{
+		free_task_struct(chosen_for_balance);
+		chosen_for_balance = NULL;
+	}
+	if(memory_balancing_counter-- == 0 && chosen_for_mdp)
+	{
+		free_task_struct(chosen_for_mdp);
+		chosen_for_mdp = NULL;
+	}
+	spin_unlock_irq(&whereto_lock);
+}
+
+void
+mosix_clear_statistics(void)
+{
+	register struct mosix_task *m = &current->mosix;
+
+	m->ndemandpages = 0;
+	m->nsyscalls = 0;
+	m->ncopyouts = 0;
+	m->copyoutbytes = 0;
+	m->ncopyins = 0;
+	m->copyinbytes = 0;
+	m->iocounter = 0;
+	m->cutime = 0;
+	m->dctime = 0;
+	m->pagetime = 0;
+	read_lock(&tasklist_lock);
+	m->decsecs = 0;
+	read_unlock(&tasklist_lock);
+	spin_lock_irq(&whereto_lock);
+	m->last_consider = 0;
+	m->last_mconsider = time_now();
+	spin_unlock_irq(&whereto_lock);
+	if(m->dflags & (DREMOTE|DDEPUTY))
+		m->uttime = 0;
+	else
+		m->uttime = -current->times.tms_utime;
+#ifdef CONFIG_MOSIX_DFSA
+	m->copy_ins = 0;
+	m->bytes_in = 0;
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef CONFIG_MOSIX_FS
+	if(m->mfs_stats)
+		m->mfs_stats->nnodes = 0;
+#endif /* CONFIG_MOSIX_FS */
+}
+
+#ifdef CONFIG_MOSIX_TOPOLOGY
+#define sel_routine(routine, struct_name)				\
+static int								\
+routine(struct struct_name *costs, int with)				\
+{									\
+	register int i;							\
+									\
+	for(i = 0 ; i < MAX_MOSIX_TOPOLOGY ; i++ , costs++)		\
+	{								\
+		if(!costs->first)					\
+			return(i);					\
+		if(!costs->last)					\
+		{							\
+			if(with != costs->first)			\
+				return(i);				\
+		}							\
+		else if((costs->last >= costs->first) ?			\
+			(with >= costs->first && with <= costs->last) :	\
+			(with > costs->first || with < costs->last))	\
+				return(i);				\
+	}								\
+	return(0);							\
+}
+
+sel_routine(select_cost, opcost)
+#ifdef CONFIG_MOSIX_FS
+sel_routine(select_mfscost, mfs_cost)
+#endif /* CONFIG_MOSIX_FS */
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+
+int64_t
+#ifdef CONFIG_MOSIX_TOPOLOGY
+io_cost(struct mosix_task *m, struct opcost *costs, int with)
+#else
+io_cost(struct mosix_task *m, struct opcost *costs)
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+{
+	int64_t b, e;
+
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	costs += select_cost(costs, with);
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+	b = m->copyoutbytes * costs->outkb + m->copyinbytes * costs->inkb;
+	e = m->ndemandpages * costs->page + m->nsyscalls * costs->syscall;
+	if(costs->out || costs->in)	/* they are usually 0, so save time */
+#if COPY_COUNTER_MULTIPLIER != EVENT_COUNTER_VALUE
+#warning no reason they should not be the same, but inefficient code provided:
+		return((b >> 10) + (e >> EVENT_COUNTER_SHIFT) +
+			(m->ncopyouts * costs->out + m->ncopyins * costs->in) /
+						COPY_COUNTER_MULTIPLIER);
+#else
+		e += m->ncopyouts * costs->out + m->ncopyins * costs->in;
+#endif
+#if EVENT_COUNTER_SHIFT == 10
+	/* we are lucky that the cost of a system call is the same
+	 * order of magnitude as copying 1KB to/from user-space
+	 */
+	return((b + e) >> 10);
+#else
+	return((b >> 10) + (e >> EVENT_COUNTER_SHIFT));
+#endif
+}
+
+int64_t
+remote_costs_in_ms(struct mosix_task *m)
+{
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	return(io_cost(m, m->depcost, PE) * STD_SPD / m->depspeed +
+				io_cost(m, remote_here_adjusted, m->deppe));
+#else
+	return(io_cost(m, m->depcost) * STD_SPD / m->depspeed +
+				io_cost(m, remote_here_adjusted));
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+}
+
+#ifdef CONFIG_MOSIX_FS
+
+enum mfs_where {MFS_CLIENT, MFS_SERVER};
+
+int64_t
+#ifdef CONFIG_MOSIX_TOPOLOGY
+mfs_cos(int64_t conns, int64_t inbytes, int64_t outbytes,
+			struct mfs_cost *costs, enum mfs_where type, int with)
+#else
+mfs_cos(int64_t conns, int64_t inbytes, int64_t outbytes, enum mfs_where type)
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+{
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	if(with == 0)
+		with = PE;
+	costs += select_mfscost(costs, with);
+#else
+	struct mfs_cost *costs = mfs_cost;
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+	if(type == MFS_CLIENT)
+		return(conns * costs->MFS_CONN_C + ((inbytes*costs->MFS_INKB_C +
+					outbytes * costs->MFS_OUTKB_C) >> 10));
+	else
+		return(conns * costs->MFS_CONN_S + ((inbytes*costs->MFS_INKB_S +
+					outbytes * costs->MFS_OUTKB_S) >> 10));
+}
+#endif /* CONFIG_MOSIX_FS */
+
+void
+add_statistics_to_ancesstor(struct task_struct *p, struct task_struct *pp)
+{
+	struct mosix_task *m = &p->mosix;
+	struct mosix_task *mm = &pp->mosix;
+	int remote = (m->dflags & DREMOTE);
+	int64_t ut, age;
+	unsigned long newcounter;
+
+	lock_mosix();
+	age = ticks_to_ms(p->times.tms_utime + m->uttime) + m->cutime;
+	ut = age - m->dctime;
+	if(remote)
+		age += remote_costs_in_ms(m);
+	if(age > 4 * MILLION) 
+	/* over 2.4 seconds, son is too old and not dependent any more */
+	{
+		unlock_mosix();
+		return;
+	}
+	mm->cutime += ut;
+	mm->nsyscalls += m->nsyscalls;
+	mm->ncopyouts += m->ncopyouts;
+	mm->copyoutbytes += m->copyoutbytes;
+	mm->ncopyins += m->ncopyins;
+	mm->copyinbytes += m->copyinbytes;
+	mm->ndemandpages += m->ndemandpages;
+	if(remote)
+	{
+		newcounter = mm->iocounter + m->ndemandpages + m->nsyscalls +
+				m->ncopyouts + m->copyoutbytes +
+				m->ncopyins + m->copyinbytes;
+		if((newcounter ^ mm->iocounter) & 0xfff00000)
+		{
+			mosix_add_to_whereto(pp, IOBALANCE);
+			mm->iocounter = 0;
+		}
+		else
+			mm->iocounter = newcounter;
+	}
+	mm->pagetime += m->pagetime;
+#ifdef CONFIG_MOSIX_FS
+	if(mfs_add_stats(m->mfs_stats, mm->mfs_stats, mm))
+		mosix_add_to_whereto(pp, MFSBALANCE);
+#endif /* CONFIG_MOSIX_FS */
+	unlock_mosix();
+}
+
+/*
+ * produce statistics at the end of local system-calls:
+ */
+void
+mosix_local_syscall(void)
+{
+	register struct mosix_task *m = &current->mosix;
+
+#ifdef CONFIG_MOSIX_DFSA
+	if(m->dflags & (DDEPUTY|DREMOTE|DSTATSDOWN))
+	{
+		m->copy_ins = m->bytes_in = 0;
+		m->dflags &= ~DSTATSDOWN;
+		return;
+	}
+	if(m->copy_ins)
+	{
+		m->ncopyins += m->copy_ins * COPY_COUNTER_MULTIPLIER;
+		m->copyinbytes += m->bytes_in;
+		m->copy_ins = m->bytes_in = 0;
+	}
+#else
+	if(!(m->dflags & (DDEPUTY|DREMOTE)))
+#endif /* CONFIG_MOSIX_DFSA */
+		m->nsyscalls += EVENT_COUNTER_VALUE;
+}
+
+/*
+ * altruistic load:
+ * this function takes into account the cost of a load not only on a given
+ * process, but also on the other processes in its environment.
+ * When there are enough processors to take the load, a process gets served as
+ * soon as practicable, as fast as the processor can run, eg. by the threshold.
+ * Otherwise, there is a cost which is:
+ * given L=load, N=ncpus:
+ * For the process itself: the cost is L.
+ * For the other (N*L-1) processes:
+ *	Without the extra process, they would each need (N*L-1)/N units of time
+ *		to complete.
+ *	With the extra process, they will need L units of time to complete.
+ * the loss is therefore (N*L-1)*(L-(N*L-1)/N) = (N*L-1)*(L-L+1/N) = L - 1/N.
+ */
+
+#define	INFLOAD 0x8000000
+#ifdef CONFIG_MOSIX_LOADLIMIT
+unsigned long load_limit = 0;
+unsigned long cpu_limit = 0;
+inline int
+altload(int load, unsigned long load_remote, unsigned long load_local, 
+	unsigned long cpu_remote, unsigned long cpu_local, 
+	unsigned long speed, int ncpus, 
+	unsigned long load_limit, 
+	unsigned long llimitmode,
+	unsigned long cpu_limit,
+	unsigned long cpulimit_mode
+	)
+{
+	int threshold = MF * STD_SPD / speed;
+	switch(llimitmode) 
+	{
+	case 0:
+		if (load_limit && load > load_limit)
+			return INFLOAD;
+	break;
+	case 1:
+		if (load_limit && load_remote  > load_limit)
+			return INFLOAD;
+	case 2:
+		if (load_limit && load_local  > load_limit)
+			return INFLOAD;
+	break;
+	}
+	switch(cpulimit_mode) 
+	{
+	case 0:
+		if (cpu_limit && ((cpu_remote+cpu_local) > cpu_limit))
+			return INFLOAD;
+	break;
+	case 1:
+		if (cpu_limit && cpu_remote  > cpu_limit)
+			return INFLOAD;
+	case 2:
+		if (cpu_limit && cpu_local  > cpu_limit)
+			return INFLOAD;
+	break;
+    }
+  if(load <= threshold)
+    return(threshold);
+  if(load <= threshold + threshold/ncpus)
+    return(threshold + ncpus * load * (load-threshold) / threshold);
+  return(2 * load - threshold / ncpus);
+}
+#else
+inline int
+altload(int load, unsigned long speed, int ncpus)
+{
+	int threshold = MF * STD_SPD / speed;
+	if(load <= threshold)
+		return(threshold);
+	if(load <= threshold + threshold/ncpus)
+		return(threshold + ncpus * load * (load-threshold) / threshold);
+	return(2 * load - threshold / ncpus);
+}
+#endif
+
+int
+send_local_aload(int type)
+{
+	struct aload_h a;
+
+	read_lock_bh(&loadinfo_lock);
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	a.aload = altload(export_load, 
+			  loadinfo[0].loadremote, loadinfo[0].loadlocal,
+			  loadinfo[0].cpuremote,  loadinfo[0].cpulocal,
+			  loadinfo[0].speed, loadinfo[0].ncpus,
+			  0, 0, 0, 0);
+#else
+	a.aload = altload(export_load, loadinfo[0].speed, loadinfo[0].ncpus);
+#endif
+	read_unlock_bh(&loadinfo_lock);
+	a.freepages = export_mem();
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	memcpy(a.mfscosts, mfs_cost, sizeof(mfs_cost));
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+	return(comm_send(type, &a, sizeof(a), NULL, 0, 0));
+}
+void
+choose(void)
+{
+        int64_t priority, lastpri = 0;
+	int pri, bestpri;
+        register int load, bestload;
+	struct task_struct *p, *sel = NULL;
+	register struct mosix_task *m;
+        int mintime, very_mintime;
+	int minload;
+
+	mintime = MILLION * acpuse / (smp_num_cpus * MF);
+	very_mintime = mintime / 3;
+	minload = 4 * acpuse / smp_num_cpus;	/* normally 4*MF */
+        bestpri = mintime;
+        bestload = -1;
+	read_lock(&tasklist_lock);
+	if(!chosen_for_balance)
+	for_each_task(p)
+        if(!((m = &p->mosix)->dflags & (DDEPUTY|DFINISHED|DPASSING)) &&
+		!m->stay && !m->whereto && p != chosen_for_mdp &&
+		(!mosadmin_mode_lstay || (m->dflags & DREMOTE)))
+        {
+		priority = ticks_to_ms(p->times.tms_utime + m->uttime) +
+								m->cutime;
+		/* (note: m->dctime deliberately not taken into account:
+		 * otherwise if statistics decay too quickly, there may never
+		 * be a process chosen for migration) */
+		if(m->dflags & DREMOTE)
+#ifdef CONFIG_MOSIX_TOPOLOGY
+			priority += io_cost(m, remote_here_adjusted, m->deppe);
+#else
+			priority += io_cost(m, remote_here_adjusted);
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+		priority -= m->last_consider;
+		if(priority < 0)
+		/* it "should not" happen, but some operating systems (BSDI)
+		   can have user-time go back due to rounding... */
+			continue;
+		pri = (priority > 4*MILLION) ? 4*MILLION : priority; /*4 secs.  */
+                if(pri < bestpri)
+                {
+                        if(bestpri == mintime &&
+				/* (thrashing, or (m->load <= minload)) */
+				m->load > minload && pri >= very_mintime)
+                                pri = mintime;
+                        else
+                                continue;
+                }
+                load = m->load;
+                if(pri > bestpri || load > bestload)
+                {
+                        bestload = load;
+			if(sel)
+				free_task_struct(sel);
+			get_task_struct(p);
+                        sel = p;
+                        bestpri = pri;
+			lastpri = priority;
+                }
+        }
+	read_unlock(&tasklist_lock);
+        if(!sel)
+		return;
+	spin_lock_irq(&whereto_lock);
+	if(chosen_for_balance)
+	{
+		free_task_struct(sel);
+		spin_unlock_irq(&whereto_lock);
+		return;
+	}
+        sel->mosix.last_consider += lastpri;
+	chosen_for_balance = sel;
+	mosix_do_add_to_whereto(sel, BALANCE);
+	load_balancing_counter = BALANCING_TIMEOUT;
+	if(sel->mosix.whereto != BALANCE)
+	{
+		free_task_struct(chosen_for_balance);
+		chosen_for_balance = NULL;
+	}
+	spin_unlock_irq(&whereto_lock);
+}
+
+void
+load_balance(void)
+{
+	register int load;
+	register struct loadinfo *l;
+	unsigned int doit = 0;
+
+	if(mosadmin_mode_stay)
+		return;
+
+	read_lock_bh(&loadinfo_lock);
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	load = altload(loadinfo[0].load, 
+		       loadinfo[0].loadremote, loadinfo[0].loadlocal,
+		       loadinfo[0].cpuremote,  loadinfo[0].cpulocal,
+		       loadinfo[0].speed, loadinfo[0].ncpus,
+		       loadinfo[0].load_limit, loadinfo[0].llimitmode,
+		       loadinfo[0].cpu_limit,  loadinfo[0].cpulimitmode);
+#else
+	load = altload(loadinfo[0].load, loadinfo[0].speed, loadinfo[0].ncpus);
+#endif
+	for(l = &loadinfo[1]; l < &loadinfo[INFO_WIN] ; l++)
+	if(l->pe && l->mem > 0 && 
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	   altload(l->load, l->loadremote, l->loadlocal,
+		   l->cpuremote, l->cpulocal,
+		   l->speed, l->ncpus, 0, 0, 0, 0) <= load
+#else
+	   altload(l->load, l->speed, l->ncpus) <= load
+#endif
+	     )
+{
+		doit = 1;
+		break;
+	}
+	read_unlock_bh(&loadinfo_lock);
+        if(doit)
+                choose();
+}
+
+void
+mchoose(int need)
+{
+	int quality, bestquality = 0;
+	int df, diff = MIN_MCHOOSE_AGAIN;
+	now_t dff;
+	struct task_struct *p, *sel = NULL;
+	register struct mosix_task *m;
+
+	read_lock(&tasklist_lock);
+	if(!chosen_for_mdp)
+	for_each_task(p)
+        if(!((m = &p->mosix)->dflags & (DDEPUTY|DFINISHED|DPASSING)) &&
+		!m->stay && !m->whereto && p != chosen_for_balance &&
+		(!mosadmin_mode_lstay || (m->dflags & DREMOTE)))
+	{
+		dff = time_since(m->last_mconsider);
+		if(dff > MAX_MCHOOSE_AGAIN)
+			df = MAX_MCHOOSE_AGAIN;
+		else
+			df = dff;
+		if(df < diff)
+			continue;
+		quality = memory_relief_quality(p, need);
+		if(quality > bestquality || (quality > 0 && df > diff))
+                {
+			if(sel)
+				free_task_struct(sel);
+			get_task_struct(p);
+                        sel = p;
+                        bestquality = quality;
+			diff = df;
+                }
+        }
+	read_unlock(&tasklist_lock);
+        if(!sel)
+		return;
+	spin_lock_irq(&whereto_lock);
+	if(chosen_for_mdp)
+	{
+		free_task_struct(sel);
+		spin_unlock_irq(&whereto_lock);
+		return;
+	}
+	sel->mosix.page_allocs = 0;
+	sel->mosix.last_mconsider = time_now();
+	chosen_for_mdp = sel;
+	mosix_do_add_to_whereto(sel, MEMBALANCE);
+	memory_balancing_counter = BALANCING_TIMEOUT;
+	if(sel->mosix.whereto != MEMBALANCE)
+	{
+		free_task_struct(chosen_for_mdp);
+		chosen_for_mdp = NULL;
+	}
+	spin_unlock_irq(&whereto_lock);
+}
+
+void
+memory_balance(void)
+{
+	register struct loadinfo *l;
+	int need;
+	unsigned int doit = 0;
+
+	if(mosadmin_mode_stay || mosadmin_mode_quiet ||
+		(need = memory_badly_required()) <= 0)
+		return;
+	read_lock_bh(&loadinfo_lock);
+	for(l = &loadinfo[1]; l < &loadinfo[INFO_WIN] ; l++)
+	if(l->pe && l->mem > MIN_EXPECTED_PROC_SIZE)
+	{
+		doit = 1;
+		break;
+	}
+	read_unlock_bh(&loadinfo_lock);
+	if(doit)
+		mchoose(need);
+}
+
+void
+changed_my_mind_and_staying(void)
+{
+	current->mosix.pages_i_bring = 0;
+}
+
+void
+ask_deputy_to_goto(int where)
+{
+	void *head;
+	int hlen;
+
+	if(comm_send(DEP_CONSIDER|REPLY, &where, sizeof(int), NULL, 0, 0) ||
+		(where && remote_wait(DEP_CONSIDER, &head, &hlen)))
+		remote_disappear();
+	if(where)
+		comm_free(head);
+}
+
+struct sonstats
+{
+	int64_t utime;		/* ms */
+	int64_t ndemandpages;
+	int64_t nsyscalls;
+	int64_t ncopyouts;
+	int64_t copyoutbytes;
+	int64_t ncopyins;
+	int64_t copyinbytes;
+	int64_t pagetime;	/* ms */
+#ifdef CONFIG_MOSIX_FS
+	struct mfs_stats mfs;
+#endif /* CONFIG_MOSIX_FS */
+};
+
+void
+consider(int reason, struct sonstats *sons)
+{
+#define	MAX_CONSIDERED	(INFO_WIN+1+MAX_MFS_STATNODES)
+#if MAX_CONSIDERED > 127
+#error char is not enough for map
+#endif /*MAX_CONSIDERED*/
+	struct task_struct *p = current;
+	register struct mosix_task *m = &p->mosix;
+	int mach[MAX_CONSIDERED], aload[MAX_CONSIDERED];
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	unsigned long load_limit_[MAX_CONSIDERED];
+	unsigned long load_[MAX_CONSIDERED];
+	unsigned long load_remote_[MAX_CONSIDERED];
+	unsigned long llimit_mode_[MAX_CONSIDERED];
+	unsigned long load_local_[MAX_CONSIDERED];
+	unsigned long cpu_limit_[MAX_CONSIDERED];
+	unsigned long cpu_remote_[MAX_CONSIDERED];
+	unsigned long cpulimit_mode_[MAX_CONSIDERED];
+	unsigned long cpu_local_[MAX_CONSIDERED];
+#endif
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	struct costinfo
+	{
+		struct opcost opcost[MAX_MOSIX_TOPOLOGY];
+#ifdef CONFIG_MOSIX_FS
+		struct mfs_cost mfscost[MAX_MOSIX_TOPOLOGY];
+#endif /* CONFIG_MOSIX_FS */
+	} *costinfo = NULL;
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+#ifdef CONFIG_MOSIX_FS
+	struct mfs_stats *mfs_tot;
+	char map[MAX_MFS_STATNODES];
+	int orig_n;
+#endif /* CONFIG_MOSIX_FS */
+	double costs[MAX_CONSIDERED];
+	register int i, n = 0, j, k;
+	int depmach = -1;
+	double tim, dtim, rtim;
+	int remote = (m->dflags & DREMOTE) ? 1 : 0;
+	int64_t ms;
+	struct aload_h a;
+
+	if((m->stay & DSTAY) || !PE || mosadmin_mode_quiet)
+		goto out;
+	if(reason && (m->stay || mosadmin_mode_stay ||
+		(mosadmin_mode_lstay && !(m->dflags & DREMOTE))))
+	{
+		goto out;
+	}
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	if(!(costinfo = (struct costinfo *)
+		kmalloc(sizeof(struct costinfo) * MAX_CONSIDERED, GFP_KERNEL)))
+	{
+		goto out;
+	}
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+	m->migpages = count_migrating_pages();
+#ifdef CONFIG_MOSIX_FS
+	if(sons && sons->mfs.nnodes)
+	{
+		mfs_tot = &sons->mfs;
+		mfs_add_stats(m->mfs_stats, mfs_tot, NULL);
+	}
+	else
+		mfs_tot = m->mfs_stats;
+#endif /* CONFIG_MOSIX_FS */
+	if(remote)
+	{
+	      if(remote_request(REM_GETALOAD, NULL, 0, NULL, 0, 0,
+			(void **)&a, -sizeof(a)))
+		{
+			printk("%s: failed to send getaload - exiting\n",
+				desc_mostask(m));
+			remote_disappear();
+		}
+		depmach = m->deppe;
+		aload[0] = a.aload;
+		if(reason != IOBALANCE && a.freepages < m->migpages)
+			aload[0] += INFLOAD;
+		/* deliberately leave costinfo[0].opcost undefined! */
+#if defined(CONFIG_MOSIX_FS) && defined(CONFIG_MOSIX_TOPOLOGY)
+		memcpy(costinfo[0].mfscost, a.mfscosts, sizeof(a.mfscosts));
+#endif /* CONFIG_MOSIX_FS && CONFIG_MOSIX_TOPOLOGY */
+		mach[n++] = GOBACKHOME;
+	}
+	read_lock_bh(&loadinfo_lock);
+	for(i = 0 ; i < INFO_WIN ; i++)
+#ifdef CONFIG_MOSIX_CHEAT_MIGSELF
+	if(loadinfo[i].pe && (!i || loadinfo[i].pe != depmach)
+#else
+	if(loadinfo[i].pe && loadinfo[i].pe != depmach
+#endif /* CONFIG_MOSIX_CHEAT_MIGSELF */
+		&& (i == 0 || (loadinfo[i].mem >= m->migpages &&
+						loadinfo[i].free_slots)))
+	{
+#ifdef CONFIG_MOSIX_TOPOLOGY
+		memcpy(costinfo[n].opcost, loadinfo[i].costs,
+						sizeof(loadinfo[i].costs));
+#ifdef CONFIG_MOSIX_FS
+		memcpy(costinfo[n].mfscost, loadinfo[i].mfscosts,
+						sizeof(loadinfo[i].mfscosts));
+#endif /* CONFIG_MOSIX_FS */
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+		/* CONFIG_MOSIX_LOADLIMIT*/
+#ifdef CONFIG_MOSIX_LOADLIMIT
+		/* If process is remote and node is overloaded then it has to migrate
+		 * out of curren node */
+		if (i || (remote && !i))
+		  aload[n] = altload(loadinfo[i].load, loadinfo[i].loadremote, 
+				     loadinfo[i].loadlocal,
+				     loadinfo[i].cpuremote,
+				     loadinfo[i].cpulocal,
+				     loadinfo[i].speed,
+				     loadinfo[i].ncpus, loadinfo[i].load_limit,
+				     loadinfo[i].llimitmode,
+				     loadinfo[i].cpu_limit,
+				     loadinfo[i].cpulimitmode);
+		else
+		  aload[n] = altload(loadinfo[i].load, loadinfo[i].loadremote,
+				     loadinfo[i].loadlocal,
+				     loadinfo[i].cpuremote,
+				     loadinfo[i].cpulocal,
+				     loadinfo[i].speed,
+				     loadinfo[i].ncpus, 0, 0, 0, 0);
+#else
+		aload[n] = altload(loadinfo[i].load, loadinfo[i].speed,
+				loadinfo[i].ncpus);
+
+#endif
+#ifdef CONFIG_MOSIX_LOADLIMIT
+		load_limit_[n] = loadinfo[i].load_limit;
+		load_[n] = loadinfo[i].load;
+		load_remote_[n] = loadinfo[i].loadremote;
+		llimit_mode_[n] = loadinfo[i].llimitmode;
+		load_local_[n] = loadinfo[i].loadlocal;
+		cpu_limit_[n] = loadinfo[i].cpu_limit;
+		cpu_remote_[n] = loadinfo[i].cpuremote;
+		cpu_local_[n] = loadinfo[i].cpulocal;
+		cpulimit_mode_[n] = loadinfo[i].cpulimitmode;
+#endif
+		/* CONFIG_MOSIX_LOADLIMIT:
+		 * aload has to be set inifinity if loadinfo[i].load is greater
+		 * then loadinfo[i].load_limit */
+		
+		if(i)
+		{
+			k = loadinfo[i].pe;
+			if(m->dflags & DMIGFILTER)
+			switch(m->mask.migpolicy)
+			{
+			case 0:	/* MIG_POLICY_DENY */
+				if((m->mask.mignodes >> (k - 1)) & 1)
+					continue;
+				break;
+			case 1:	/* MIG_POLICY_ALLOW */
+				if(!((m->mask.mignodes >> (k - 1)) & 1))
+					continue;
+				break;
+			}
+			mach[n] = k;
+		}
+		else
+		{
+			mach[n] = 0;
+			if(reason == MEMBALANCE)
+			{
+				if(remote)
+					continue;
+				aload[n] += INFLOAD;
+			}
+		}
+		n++;
+	}
+	read_unlock_bh(&loadinfo_lock);
+#ifdef CONFIG_MOSIX_FS
+	/* collect info on MFS nodes */
+	orig_n = n;
+	if(mfs_tot)
+	for(i = 0 ; i < mfs_tot->nnodes ; i++)
+	{
+		struct loadinfo info;
+
+		if(mfs_tot->conns[i] < 10 &&
+			(mfs_tot->inbytes[i] + mfs_tot->outbytes[i]) < 1000000)
+			continue;
+		k = mfs_tot->nodes[i];
+		if(k == PE || k == depmach)
+			continue;
+		for(j = 1 ; j < orig_n ; j++)
+		if(mach[j] == k)
+			goto not_this_one;
+		if(balance_get_load(k, &info))
+			continue;
+		if (info.mem < m->migpages || !info.free_slots)
+			continue;
+		mach[n] = k;
+		/* CONFIG_MOSIX_LOADLIMIT */
+#ifdef CONFIG_MOSIX_LOADLIMIT
+		/* If process is remote and node is overloaded then it has to migrate
+		 * out of current node */
+		if (k != PE || (k==PE && remote))
+		  aload[n] = altload(info.load, info.loadremote, info.loadlocal,
+				     info.cpuremote, info.cpulocal,
+				     info.speed,
+		     		     info.ncpus, info.load_limit, info.llimitmode,
+				     info.cpu_limit, info.cpulimitmode);
+		else
+	           aload[n] = altload(info.load, info.loadremote, info.loadlocal,
+				      info.cpuremote, info.cpulocal,
+				      info.speed, info.ncpus, 0, 0, 0, 0);
+#else
+		aload[n] = altload(info.load, info.speed, info.ncpus);
+#endif
+#ifdef CONFIG_MOSIX_LOADLIMIT
+		load_limit_[n] = info.load_limit;
+		load_[n] = info.load;
+		load_remote_[n] = info.loadremote;
+		load_local_[n] = info.loadlocal;
+		llimit_mode_[n] = info.llimitmode;
+		cpu_limit_[n] = info.cpu_limit;
+		cpu_remote_[n] = info.cpuremote;
+		cpu_local_[n] = info.cpulocal;
+		cpulimit_mode_[n] = info.cpulimitmode;
+#endif
+		/* CONFIG_MOSIX_LOADLIMIT:
+		 * aload has to be set inifinity if loadinfo[i].load is greater
+		 * then loadinfo[i].load_limit */
+#ifdef CONFIG_MOSIX_TOPOLOGY
+		memcpy(costinfo[n].opcost, info.costs, sizeof(info.costs));
+		memcpy(costinfo[n].mfscost, info.mfscosts,
+							sizeof(info.mfscosts));
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+		n++;
+		not_this_one:;
+	}
+#endif /* CONFIG_MOSIX_FS */
+	if(n == 0 || (n == 1 && mach[0] == 0))
+		goto out;	/* save time */
+#ifdef CONFIG_MOSIX_FS
+	/* prepare the MFS mapping */
+	if(mfs_tot)
+	for(i = mfs_tot->nnodes - 1 ; i >= 0 ; i--)
+	{
+		k = mfs_tot->nodes[i];
+		if(k == PE)
+			map[i] = remote;
+		else if(remote && k == m->deppe)
+			map[i] = 0;
+		else
+		{
+			map[i] = -1;
+			for(j = n - 1 ; j > 0 ; j--)
+			if(mach[j] == k)
+			{
+				map[i] = j;
+				break;
+			}
+		}
+	}
+#endif /* CONFIG_MOSIX_FS */
+	/* we must NOT sleep throughout the following FP calculations:*/
+	kernel_fpu_begin();
+	init_fpu();
+	ms = ticks_to_ms(p->times.tms_utime+m->uttime) + m->cutime - m->dctime;
+	if(sons)
+		ms += sons->utime;
+	if((m->dpolicy & DADV_POLICY) == DADV_NOCPU)
+		tim = 0.0;
+	else
+		/* secs on a std. machine */
+		tim = ms / DMILLION * cpuspeed / STD_SPD;
+	if(reason == MEMBALANCE)
+		tim += (m->pagetime + (sons ? sons->pagetime : 0)) / DMILLION;
+	for(i = 0 ; i < n ; i++)
+		costs[i] = tim * aload[i] / MF;
+	if((m->dpolicy & DADV_POLICY) == DADV_CPU)
+		goto skip_comm;
+	if(sons)	/* temporarily add */
+	{
+		lock_mosix();
+		m->ndemandpages += sons->ndemandpages;
+		m->nsyscalls += sons->nsyscalls;
+		m->ncopyouts += sons->ncopyouts;
+		m->copyoutbytes += sons->copyoutbytes;
+		m->ncopyins += sons->ncopyins;
+		m->copyinbytes += sons->copyinbytes;
+		unlock_mosix();
+	}
+	for(i = 1 ; i < n ; i++)
+	{
+#ifdef CONFIG_MOSIX_TOPOLOGY
+		dtim = io_cost(m, remote ? m->depcost : deputy_here, mach[i]);
+		rtim = io_cost(m, costinfo[i].opcost, m->deppe);
+#else
+		dtim = io_cost(m, remote ? m->depcost : deputy_here);
+		rtim = io_cost(m, &remote_here);
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+		costs[i] += (dtim * aload[0] + rtim * aload[i]) / (DMILLION*MF);
+	}
+	if(sons)	/* restore */
+	{
+		lock_mosix();
+		m->ndemandpages -= sons->ndemandpages;
+		m->nsyscalls -= sons->nsyscalls;
+		m->ncopyouts -= sons->ncopyouts;
+		m->copyoutbytes -= sons->copyoutbytes;
+		m->ncopyins -= sons->ncopyins;
+		m->copyinbytes -= sons->copyinbytes;
+		unlock_mosix();
+	}
+#ifdef CONFIG_MOSIX_FS
+	if(!mfs_tot)
+		goto skip_comm;
+	for(i = 0 ; i < n ; i++)
+	for(j = 0 ; j < mfs_tot->nnodes ; j++)
+	if((k = map[j]) != -1 && k != i)
+	{
+		int c = mfs_tot->conns[j];
+		int in = mfs_tot->inbytes[j];
+		int out = mfs_tot->outbytes[j];
+
+#ifdef CONFIG_MOSIX_TOPOLOGY
+		dtim = mfs_cos(c, in, out, costinfo[k].mfscost, MFS_SERVER,
+								mach[i]);
+		rtim = mfs_cos(c, in, out, costinfo[i].mfscost, MFS_CLIENT,
+								mach[k]);
+#else
+		dtim = mfs_cos(c, in, out, MFS_SERVER);
+		rtim = mfs_cos(c, in, out, MFS_CLIENT);
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+		costs[i] += (dtim * aload[k] + rtim * aload[i]) / (DMILLION*MF);
+	}
+#endif /* CONFIG_MOSIX_FS */
+	skip_comm:
+	if (reason != MEMBALANCE)
+	{
+		/* migration cost: */
+		double decay_factor;
+
+		if(m->dctime > 0)	/* decay occured */
+		{
+			ms = ticks_to_ms(p->times.tms_utime + m->uttime);
+			if(ms)
+				decay_factor = ((double)(ms - m->dctime)) / ms;
+			else
+			{
+				decay_factor = 1.0;
+			}
+		}
+		else
+			decay_factor = 1.0;
+		decay_factor /= DMILLION; /* to save multiple divisions later */
+#ifdef CONFIG_MOSIX_TOPOLOGY
+		for(i = 0 ; i < n ; i++)
+		if(i != remote)
+		{
+			j = select_cost(deputy_here, i ? mach[i] : m->deppe);
+			costs[i] += decay_factor *
+				(mosix_cost[j].MIGRATION_BASIC +
+				m->migpages * mosix_cost[j].MIGRATION_PER_PAGE);
+		}
+#else
+		tim = decay_factor * (mosix_cost[0].MIGRATION_BASIC +
+			m->migpages * mosix_cost[0].MIGRATION_PER_PAGE);
+		for(i = 0 ; i < n ; i++)
+		if(i != remote)
+			costs[i] += tim;
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+	}
+	/* sort by least cost */
+	for(i = 0 ; i < n-1 ; i++)
+	for(j = i+1 ; j < n ; j++)
+	if(costs[i] > costs[j])
+	{
+		tim = costs[i];
+		costs[i] = costs[j];
+		costs[j] = tim;
+		k = mach[i];
+		mach[i] = mach[j];
+		mach[j] = k;
+	}
+	kernel_fpu_end();
+	m->loadhere = aload[remote];
+	for(i = 0 ; i < n ; i++)
+	{
+		if((k = mach[i]) == 0)
+			goto out;
+#ifdef CONFIG_MOSIX_LOADLIMIT
+		/* if destination node k is overloaded then skip it */
+		switch (llimit_mode_[k])
+	    	  {
+    		  case 0:
+		    if (load_limit_[k] && (load_[k] > load_limit_[k]) && 
+			!(remote && k == depmach))
+		      continue;
+		    break;
+		  case 1:
+		    if (load_limit_[k] && (load_remote_[k] > load_limit_[k]) && 
+			!(remote && k == depmach) )
+		      continue;
+		    break;
+		  case 2:
+		    if (load_limit_[k] && (load_local_[k] > load_limit_[k]) && 
+			!(remote && k == depmach) )
+		      continue;
+		    break;
+		  }
+		switch (cpulimit_mode_[k])
+		  {
+		  case 0:
+		    if (cpu_limit_[k] && 
+			(cpu_remote_[k]+cpu_local_[k] > cpu_limit_[k]) && 
+			!(remote && k == depmach))
+		      continue;
+		    break;
+		  case 1:
+		    if (cpu_limit_[k] && (cpu_remote_[k] > cpu_limit_[k]) && 
+			!(remote && k == depmach) )
+		      continue;
+		    break;
+		  case 2:
+		    if (cpu_limit_[k] && (cpu_local_[k] > cpu_limit_[k]) && 
+			!(remote && k == depmach) )
+		      continue;
+		    break;
+		  }
+#endif
+		if(remote)
+		{
+			ask_deputy_to_goto(k);
+		}
+		else if(passto(k, reason) == 0)
+			goto out;
+		/* conditions changed meanwhile? */
+		if(mosadmin_mode_quiet || (reason && (mosadmin_mode_stay ||
+			(mosadmin_mode_lstay && !(m->dflags & DREMOTE)))))
+			goto out;
+	}
+	out:
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	if(costinfo)
+		kfree(costinfo);
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+	m->migpages = 0;
+	unchoose_me();
+	if(m->dflags & DREMOTE)
+		ask_deputy_to_goto(0);
+}
+
+void
+unchoose_me(void)
+{
+	struct task_struct *p = current;
+	unsigned int l = 0, m = 0;
+
+	spin_lock_irq(&whereto_lock);
+	if(p == chosen_for_balance)
+	{
+		free_task_struct(p);
+		chosen_for_balance = NULL;
+		l = 1;
+	}
+	else if(p == chosen_for_mdp)
+	{
+		free_task_struct(p);
+		chosen_for_mdp = NULL;
+		m = 1;
+	}
+	spin_unlock_irq(&whereto_lock);
+	if(l)
+		load_balance();
+	else if(m)
+		memory_balance();
+}
+
+int
+mosix_forkmigrate(void)
+{
+	struct task_struct *me = current;
+	struct task_struct *p, *a;
+        register struct mosix_task *q;
+	struct sonstats s;
+	register int remote;
+	int64_t age;
+	unsigned int any = 0;
+
+	if(me->mosix.dflags & DDEPUTY)
+		panic("forkmigrate: DEPUTY");
+	if(me->mosix.stay || !PE)
+		return(0);
+	remote = (me->mosix.dflags & DREMOTE) != 0;
+	lock_mosix();
+	read_lock(&tasklist_lock);
+	for_each_task(p)
+	for(a = p->mosix.ancesstor ; a ; a = a->mosix.ancesstor)
+        if(a == me)
+	{
+		q = &p->mosix;
+		age = ticks_to_ms(p->times.tms_utime + q->uttime) + q->cutime;
+		if(remote)
+			age += remote_costs_in_ms(q);
+		else
+			age += ticks_to_ms(p->times.tms_stime);
+		if(age > 4 * MILLION) 
+		/* over 4 seconds, descendant is no longer dependent */
+		{
+			q->ancesstor = NULL;
+			break;
+		}
+		if(!any)
+		{
+			any = 1;
+			memset(&s, 0, sizeof s);
+		}
+		s.utime += ticks_to_ms(p->times.tms_utime + q->uttime) +
+							q->cutime - q->dctime;
+		/* we need not worry about the "q->uttime" part of q->dctime
+		   on a local process: if the process ever migrated, it would
+		   not be dependent and we would never reach here!
+		*/
+		s.nsyscalls += q->nsyscalls;
+		s.ncopyouts += q->ncopyouts;
+		s.copyoutbytes += q->copyoutbytes;
+		s.ncopyins += q->ncopyins;
+		s.copyinbytes += q->copyinbytes;
+		s.pagetime += q->pagetime;
+#ifdef CONFIG_MOSIX_FS
+		mfs_add_stats(q->mfs_stats, &s.mfs, NULL);
+#endif /* CONFIG_MOSIX_FS */
+		break;
+	}
+	read_unlock(&tasklist_lock);
+	unlock_mosix();
+	if(!any)
+		return(0);
+	if(remote && comm_send(REM_CONSIDERING, NULL, 0, NULL, 0, 0))
+		remote_disappear();
+        consider(BALANCE, &s);
+	return(me->mosix.dflags & DDEPUTY);
+	/* for local processes, DDEPUTY means we moved,
+	 * and REMOTE processes do not care for result -
+	 * for they would never reach here if migrated.
+	 */
+}
+
+int
+send_with_miginfo(int type, void *header, int hdsz)
+{
+	struct miginfo mi;
+	register struct mosix_task *m = &current->mosix;
+
+	mi.aload = m->loadhere;
+	mi.pages = m->migpages ? : count_migrating_pages();
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	mi.remote = (current->mosix.dflags & DREMOTE) ? 1 : 0;
+	mi.deppe = current->mosix.deppe;
+#endif
+	return(comm_send(type, header, hdsz, (char *)&mi, sizeof(mi), 0));
+}
+
+int
+balance_commit_mig(int reason, int pages_i_bring)
+{
+	int me, him;
+	struct miginfo mi;
+
+	if(comm_copydata(&mi, sizeof(mi) | COMM_ZEROCOPYOK, 0))
+		goto commit;	/* no MOSIX on other side! */
+	switch(reason) {
+	case 0:
+	case IOBALANCE:
+	case MFSBALANCE:
+		goto commit;
+	default:
+		read_lock_bh(&loadinfo_lock);
+#ifdef CONFIG_MOSIX_LOADLIMIT
+		if (mi.remote && mi.deppe == PE)
+		  me = altload(export_load, loadinfo[0].loadremote,
+			       loadinfo[0].loadlocal,
+			       loadinfo[0].loadremote,
+			       loadinfo[0].loadlocal,
+			       loadinfo[0].speed,
+			       loadinfo[0].ncpus, 0, 0, 0, 0);
+		else
+		  me = altload(export_load, loadinfo[0].loadremote,
+			       loadinfo[0].loadlocal,
+			       loadinfo[0].cpuremote,
+			       loadinfo[0].cpulocal,
+			       loadinfo[0].speed,
+			       loadinfo[0].ncpus, loadinfo[0].load_limit,
+			       loadinfo[0].llimitmode,
+			       loadinfo[0].cpu_limit,
+			       loadinfo[0].cpulimitmode);
+
+#else
+		me = altload(export_load, loadinfo[0].speed,
+			     loadinfo[0].ncpus);
+#endif
+		read_unlock_bh(&loadinfo_lock);
+		him = mi.aload;
+		if(me > him)
+			break;
+		/* fall through - check memory as well */
+	case MEMBALANCE:
+		me = export_mem();
+		if(me >= mi.pages)
+			goto commit;
+		break;
+	}
+	return(0);	/* NO! */
+ commit:
+	info_someone_came_in();
+	return(1);
+}
